export interface UserDefinedOptions {
    [prop: string]: any;
}
export declare type TFunction8<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1, T2, T3, T4, T5, T6, T7];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction7<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1, T2, T3, T4, T5, T6];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction6<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1, T2, T3, T4, T5];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction5<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1, T2, T3, T4];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction4<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1, T2, T3];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction3<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1, T2];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction2<T0 extends TSchema, T1 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0, T1];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction1<T0 extends TSchema, U extends TSchema> = {
    type: 'function';
    arguments: [T0];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction0<U extends TSchema> = {
    type: 'function';
    arguments: [];
    returns: U;
} & UserDefinedOptions;
export declare type TFunction = TFunction8<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TFunction7<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TFunction6<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TFunction5<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TFunction4<TSchema, TSchema, TSchema, TSchema, TSchema> | TFunction3<TSchema, TSchema, TSchema, TSchema> | TFunction2<TSchema, TSchema, TSchema> | TFunction1<TSchema, TSchema> | TFunction0<TSchema>;
export declare type TConstructor8<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1, T2, T3, T4, T5, T6, T7];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor7<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1, T2, T3, T4, T5, T6];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor6<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1, T2, T3, T4, T5];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor5<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1, T2, T3, T4];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor4<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1, T2, T3];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor3<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1, T2];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor2<T0 extends TSchema, T1 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0, T1];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor1<T0 extends TSchema, U extends TSchema> = {
    type: 'constructor';
    arguments: [T0];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor0<U extends TSchema> = {
    type: 'constructor';
    arguments: [];
    returns: U;
} & UserDefinedOptions;
export declare type TConstructor = TConstructor8<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TConstructor7<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TConstructor6<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TConstructor5<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TConstructor4<TSchema, TSchema, TSchema, TSchema, TSchema> | TConstructor3<TSchema, TSchema, TSchema, TSchema> | TConstructor2<TSchema, TSchema, TSchema> | TConstructor1<TSchema, TSchema> | TConstructor0<TSchema>;
export declare type TContract = TFunction | TConstructor | TPromise<any> | TVoid | TUndefined;
export declare type TPromise<T extends TSchema | TVoid | TUndefined> = {
    type: 'promise';
    item: T;
} & UserDefinedOptions;
export declare type TUndefined = {
    type: 'undefined';
} & UserDefinedOptions;
export declare type TVoid = {
    type: 'void';
} & UserDefinedOptions;
export declare type TIntersect8<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema> = {
    allOf: [T0, T1, T2, T3, T4, T5, T6, T7];
} & UserDefinedOptions;
export declare type TIntersect7<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema> = {
    allOf: [T0, T1, T2, T3, T4, T5, T6];
} & UserDefinedOptions;
export declare type TIntersect6<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema> = {
    allOf: [T0, T1, T2, T3, T4, T5];
} & UserDefinedOptions;
export declare type TIntersect5<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema> = {
    allOf: [T0, T1, T2, T3, T4];
} & UserDefinedOptions;
export declare type TIntersect4<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema> = {
    allOf: [T0, T1, T2, T3];
} & UserDefinedOptions;
export declare type TIntersect3<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema> = {
    allOf: [T0, T1, T2];
} & UserDefinedOptions;
export declare type TIntersect2<T0 extends TSchema, T1 extends TSchema> = {
    allOf: [T0, T1];
} & UserDefinedOptions;
export declare type TIntersect1<T0 extends TSchema> = {
    allOf: [T0];
} & UserDefinedOptions;
export declare type TIntersect = TIntersect8<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TIntersect7<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TIntersect6<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TIntersect5<TSchema, TSchema, TSchema, TSchema, TSchema> | TIntersect4<TSchema, TSchema, TSchema, TSchema> | TIntersect3<TSchema, TSchema, TSchema> | TIntersect2<TSchema, TSchema> | TIntersect1<TSchema>;
export declare type TUnion8<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema> = {
    oneOf: [T0, T1, T2, T3, T4, T5, T6, T7];
} & UserDefinedOptions;
export declare type TUnion7<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema> = {
    oneOf: [T0, T1, T2, T3, T4, T5, T6];
} & UserDefinedOptions;
export declare type TUnion6<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema> = {
    oneOf: [T0, T1, T2, T3, T4, T5];
} & UserDefinedOptions;
export declare type TUnion5<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema> = {
    oneOf: [T0, T1, T2, T3, T4];
} & UserDefinedOptions;
export declare type TUnion4<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema> = {
    oneOf: [T0, T1, T2, T3];
} & UserDefinedOptions;
export declare type TUnion3<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema> = {
    oneOf: [T0, T1, T2];
} & UserDefinedOptions;
export declare type TUnion2<T0 extends TSchema, T1 extends TSchema> = {
    oneOf: [T0, T1];
} & UserDefinedOptions;
export declare type TUnion1<T0 extends TSchema> = {
    oneOf: [T0];
} & UserDefinedOptions;
export declare type TUnion = TUnion8<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TUnion7<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TUnion6<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TUnion5<TSchema, TSchema, TSchema, TSchema, TSchema> | TUnion4<TSchema, TSchema, TSchema, TSchema> | TUnion3<TSchema, TSchema, TSchema> | TUnion2<TSchema, TSchema> | TUnion1<TSchema>;
export declare type TTuple8<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema> = {
    type: 'array';
    items: [T0, T1, T2, T3, T4, T5, T6, T7];
    additionalItems: false;
    minItems: 8;
    maxItems: 8;
} & UserDefinedOptions;
export declare type TTuple7<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema> = {
    type: 'array';
    items: [T0, T1, T2, T3, T4, T5, T6];
    additionalItems: false;
    minItems: 7;
    maxItems: 7;
} & UserDefinedOptions;
export declare type TTuple6<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema> = {
    type: 'array';
    items: [T0, T1, T2, T3, T4, T5];
    additionalItems: false;
    minItems: 6;
    maxItems: 6;
} & UserDefinedOptions;
export declare type TTuple5<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema> = {
    type: 'array';
    items: [T0, T1, T2, T3, T4];
    additionalItems: false;
    minItems: 5;
    maxItems: 5;
} & UserDefinedOptions;
export declare type TTuple4<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema> = {
    type: 'array';
    items: [T0, T1, T2, T3];
    additionalItems: false;
    minItems: 4;
    maxItems: 4;
} & UserDefinedOptions;
export declare type TTuple3<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema> = {
    type: 'array';
    items: [T0, T1, T2];
    additionalItems: false;
    minItems: 3;
    maxItems: 3;
} & UserDefinedOptions;
export declare type TTuple2<T0 extends TSchema, T1 extends TSchema> = {
    type: 'array';
    items: [T0, T1];
    additionalItems: false;
    minItems: 2;
    maxItems: 2;
} & UserDefinedOptions;
export declare type TTuple1<T0 extends TSchema> = {
    type: 'array';
    items: [T0];
    additionalItems: false;
    minItems: 1;
    maxItems: 1;
} & UserDefinedOptions;
export declare type TTuple = TTuple8<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TTuple7<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TTuple6<TSchema, TSchema, TSchema, TSchema, TSchema, TSchema> | TTuple5<TSchema, TSchema, TSchema, TSchema, TSchema> | TTuple4<TSchema, TSchema, TSchema, TSchema> | TTuple3<TSchema, TSchema, TSchema> | TTuple2<TSchema, TSchema> | TTuple1<TSchema>;
export declare type TComposite = TIntersect | TUnion | TTuple;
export declare const modifierSymbol: unique symbol;
export declare type TOptional<T extends TSchema | TComposite> = T & {
    [modifierSymbol]: 'optional';
};
export declare type TReadonly<T extends TSchema | TComposite> = T & {
    [modifierSymbol]: 'readonly';
};
export declare type TReadonlyOptional<T extends TSchema | TComposite> = T & {
    [modifierSymbol]: 'readonly-optional';
};
export declare type TModifier = TOptional<any> | TReadonly<any> | TReadonlyOptional<any>;
export declare type FormatOption = 'date-time' | 'time' | 'date' | 'email' | 'idn-email' | 'hostname' | 'idn-hostname' | 'ipv4' | 'ipv6' | 'uri' | 'uri-reference' | 'iri' | 'uuid' | 'iri-reference' | 'uri-template' | 'json-pointer' | 'relative-json-pointer' | 'regex';
export declare type ArrayOptions = {
    minItems?: number;
    maxItems?: number;
    uniqueItems?: boolean;
} & UserDefinedOptions;
export declare type NumberOptions = {
    minimum?: number;
    exclusiveMinimum?: number;
    maximum?: number;
    exclusiveMaximum?: number;
    multipleOf?: number;
} & UserDefinedOptions;
/** Augmentation support for UserDefinedOptions. Used specifically for adding custom string formats. */
declare type UnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends ((k: infer I) => void) ? I : never;
declare type IsUnion<T> = [T] extends [UnionToIntersection<T>] ? false : true;
export declare type StringOptions = {
    minLength?: number;
    maxLength?: number;
    pattern?: string;
    format?: IsUnion<UserDefinedOptions['format']> extends true ? UserDefinedOptions['format'] | FormatOption : FormatOption;
} & Omit<UserDefinedOptions, 'format'>;
export declare type TLiteral = TStringLiteral<string> | TNumberLiteral<number> | TBooleanLiteral<boolean>;
export declare type TStringLiteral<T> = {
    type: 'string';
    enum: [T];
} & UserDefinedOptions;
export declare type TNumberLiteral<T> = {
    type: 'number';
    enum: [T];
} & UserDefinedOptions;
export declare type TBooleanLiteral<T> = {
    type: 'boolean';
    enum: [T];
} & UserDefinedOptions;
export declare type TProperties = {
    [key: string]: TSchema | TComposite | TOptional<TSchema | TComposite> | TReadonly<TSchema | TComposite>;
};
export declare type TObject<T extends TProperties> = {
    type: 'object';
    properties: T;
    required?: string[];
} & UserDefinedOptions;
export declare type TMap<T extends TSchema | TComposite> = {
    type: 'object';
    additionalProperties: T;
} & UserDefinedOptions;
export declare type TArray<T extends TSchema | TComposite> = {
    type: 'array';
    items: T;
} & ArrayOptions;
export declare type TEnum<T extends string | number> = {
    enum: Array<T>;
} & UserDefinedOptions;
export declare type TNumber = {
    type: 'number';
} & NumberOptions;
export declare type TInteger = {
    type: 'integer';
} & NumberOptions;
export declare type TString = {
    type: 'string';
} & StringOptions;
export declare type TBoolean = {
    type: 'boolean';
} & UserDefinedOptions;
export declare type TNull = {
    type: 'null';
} & UserDefinedOptions;
export declare type TAny = {} & UserDefinedOptions;
export declare type TSchema = TLiteral | TNumber | TInteger | TBoolean | TString | TObject<any> | TArray<any> | TEnum<any> | TMap<any> | TNull | TAny;
declare type StaticFunction<T> = T extends TFunction8<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer U7, infer R> ? (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>, arg5: Static<U5>, arg6: Static<U6>, arg7: Static<U7>) => Static<R> : T extends TFunction7<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer R> ? (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>, arg5: Static<U5>, arg6: Static<U6>) => Static<R> : T extends TFunction6<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer R> ? (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>, arg5: Static<U5>) => Static<R> : T extends TFunction5<infer U0, infer U1, infer U2, infer U3, infer U4, infer R> ? (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>) => Static<R> : T extends TFunction4<infer U0, infer U1, infer U2, infer U3, infer R> ? (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>) => Static<R> : T extends TFunction3<infer U0, infer U1, infer U2, infer R> ? (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>) => Static<R> : T extends TFunction2<infer U0, infer U1, infer R> ? (arg0: Static<U0>, arg1: Static<U1>) => Static<R> : T extends TFunction1<infer U0, infer R> ? (arg0: Static<U0>) => Static<R> : T extends TFunction0<infer R> ? () => Static<R> : never;
declare type StaticConstructor<T> = T extends TConstructor8<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer U7, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>, arg5: Static<U5>, arg6: Static<U6>, arg7: Static<U7>) => Static<R> : T extends TConstructor7<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>, arg5: Static<U5>, arg6: Static<U6>) => Static<R> : T extends TConstructor6<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>, arg5: Static<U5>) => Static<R> : T extends TConstructor5<infer U0, infer U1, infer U2, infer U3, infer U4, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>, arg4: Static<U4>) => Static<R> : T extends TConstructor4<infer U0, infer U1, infer U2, infer U3, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>, arg3: Static<U3>) => Static<R> : T extends TConstructor3<infer U0, infer U1, infer U2, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>, arg2: Static<U2>) => Static<R> : T extends TConstructor2<infer U0, infer U1, infer R> ? new (arg0: Static<U0>, arg1: Static<U1>) => Static<R> : T extends TConstructor1<infer U0, infer R> ? new (arg0: Static<U0>) => Static<R> : T extends TConstructor0<infer R> ? new () => Static<R> : never;
declare type StaticContract<T extends TContract> = T extends TFunction ? StaticFunction<T> : T extends TConstructor ? StaticConstructor<T> : T extends TPromise<infer U> ? Promise<Static<U>> : T extends TVoid ? void : T extends TUndefined ? undefined : never;
declare type StaticIntersect<T> = T extends TIntersect8<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer U7> ? StaticSchema<U0> & StaticSchema<U1> & StaticSchema<U2> & StaticSchema<U3> & StaticSchema<U4> & StaticSchema<U5> & StaticSchema<U6> & StaticSchema<U7> : T extends TIntersect7<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6> ? StaticSchema<U0> & StaticSchema<U1> & StaticSchema<U2> & StaticSchema<U3> & StaticSchema<U4> & StaticSchema<U5> & StaticSchema<U6> : T extends TIntersect6<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5> ? StaticSchema<U0> & StaticSchema<U1> & StaticSchema<U2> & StaticSchema<U3> & StaticSchema<U4> & StaticSchema<U5> : T extends TIntersect5<infer U0, infer U1, infer U2, infer U3, infer U4> ? StaticSchema<U0> & StaticSchema<U1> & StaticSchema<U2> & StaticSchema<U3> & StaticSchema<U4> : T extends TIntersect4<infer U0, infer U1, infer U2, infer U3> ? StaticSchema<U0> & StaticSchema<U1> & StaticSchema<U2> & StaticSchema<U3> : T extends TIntersect3<infer U0, infer U1, infer U2> ? StaticSchema<U0> & StaticSchema<U1> & StaticSchema<U2> : T extends TIntersect2<infer U0, infer U1> ? StaticSchema<U1> & StaticSchema<U0> : T extends TIntersect1<infer U0> ? StaticSchema<U0> : never;
declare type StaticUnion<T> = T extends TUnion8<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer U7> ? StaticSchema<U0> | StaticSchema<U1> | StaticSchema<U2> | StaticSchema<U3> | StaticSchema<U4> | StaticSchema<U5> | StaticSchema<U6> | StaticSchema<U7> : T extends TUnion7<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6> ? StaticSchema<U0> | StaticSchema<U1> | StaticSchema<U2> | StaticSchema<U3> | StaticSchema<U4> | StaticSchema<U5> | StaticSchema<U6> : T extends TUnion6<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5> ? StaticSchema<U0> | StaticSchema<U1> | StaticSchema<U2> | StaticSchema<U3> | StaticSchema<U4> | StaticSchema<U5> : T extends TUnion5<infer U0, infer U1, infer U2, infer U3, infer U4> ? StaticSchema<U0> | StaticSchema<U1> | StaticSchema<U2> | StaticSchema<U3> | StaticSchema<U4> : T extends TUnion4<infer U0, infer U1, infer U2, infer U3> ? StaticSchema<U0> | StaticSchema<U1> | StaticSchema<U2> | StaticSchema<U3> : T extends TUnion3<infer U0, infer U1, infer U2> ? StaticSchema<U0> | StaticSchema<U1> | StaticSchema<U2> : T extends TUnion2<infer U0, infer U1> ? StaticSchema<U0> | StaticSchema<U1> : T extends TUnion1<infer U0> ? StaticSchema<U0> : never;
declare type StaticTuple<T> = T extends TTuple8<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6, infer U7> ? [Static<U0>, Static<U1>, Static<U2>, Static<U3>, Static<U4>, Static<U5>, Static<U6>, Static<U7>] : T extends TTuple7<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5, infer U6> ? [Static<U0>, Static<U1>, Static<U2>, Static<U3>, Static<U4>, Static<U5>, Static<U6>] : T extends TTuple6<infer U0, infer U1, infer U2, infer U3, infer U4, infer U5> ? [Static<U0>, Static<U1>, Static<U2>, Static<U3>, Static<U4>, Static<U5>] : T extends TTuple5<infer U0, infer U1, infer U2, infer U3, infer U4> ? [Static<U0>, Static<U1>, Static<U2>, Static<U3>, Static<U4>] : T extends TTuple4<infer U0, infer U1, infer U2, infer U3> ? [Static<U0>, Static<U1>, Static<U2>, Static<U3>] : T extends TTuple3<infer U0, infer U1, infer U2> ? [Static<U0>, Static<U1>, Static<U2>] : T extends TTuple2<infer U0, infer U1> ? [Static<U0>, Static<U1>] : T extends TTuple1<infer U0> ? [Static<U0>] : never;
declare type StaticComposite<T extends TComposite> = T extends TIntersect ? StaticIntersect<T> : T extends TUnion ? StaticUnion<T> : T extends TTuple ? StaticTuple<T> : never;
declare type StaticLiteral<T> = T extends TStringLiteral<infer U> ? U : T extends TNumberLiteral<infer U> ? U : T extends TBooleanLiteral<infer U> ? U : never;
declare type ReadonlyOptionalPropertyKeys<T> = {
    [K in keyof T]: T[K] extends TReadonlyOptional<infer U> ? K : never;
}[keyof T];
declare type ReadonlyPropertyKeys<T> = {
    [K in keyof T]: T[K] extends TReadonly<infer U> ? K : never;
}[keyof T];
declare type OptionalPropertyKeys<T> = {
    [K in keyof T]: T[K] extends TOptional<infer U> ? K : never;
}[keyof T];
declare type PropertyKeys<T> = keyof Omit<T, OptionalPropertyKeys<T> | ReadonlyPropertyKeys<T> | ReadonlyOptionalPropertyKeys<T>>;
declare type StaticObjectPropertiesExpansion<T> = {
    readonly [K in ReadonlyOptionalPropertyKeys<T>]?: Static<T[K]>;
} & {
    readonly [K in ReadonlyPropertyKeys<T>]: Static<T[K]>;
} & {
    [K in OptionalPropertyKeys<T>]?: Static<T[K]>;
} & {
    [K in PropertyKeys<T>]: Static<T[K]>;
};
declare type StaticObjectProperties<T> = {
    [K in keyof StaticObjectPropertiesExpansion<T>]: StaticObjectPropertiesExpansion<T>[K];
};
declare type StaticSchema<T extends TSchema> = T extends TObject<infer U> ? StaticObjectProperties<U> : T extends TMap<infer U> ? {
    [key: string]: Static<U>;
} : T extends TArray<infer U> ? Array<Static<U>> : T extends TEnum<infer U> ? U : T extends TLiteral ? StaticLiteral<T> : T extends TString ? string : T extends TNumber ? number : T extends TInteger ? number : T extends TBoolean ? boolean : T extends TNull ? null : T extends TAny ? any : never;
export declare type TStatic = TComposite | TSchema | TContract | TModifier;
export declare type Static<T extends TStatic> = T extends TContract ? StaticContract<T> : T extends TComposite ? StaticComposite<T> : T extends TSchema ? StaticSchema<T> : never;
export declare class Type {
    /** Modifies the inner type T into a readonly optional T. */
    static ReadonlyOptional<T extends TSchema | TUnion | TIntersect>(item: T): TReadonlyOptional<T>;
    /** Modifies the inner type T into an optional T. */
    static Optional<T extends TSchema | TUnion | TIntersect>(item: T): TOptional<T>;
    /** Modifies the inner type T into an readonly T. */
    static Readonly<T extends TSchema | TUnion | TIntersect>(item: T): TReadonly<T>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema>(items: [T0, T1, T2, T3, T4, T5, T6, T7], options?: UserDefinedOptions): TUnion8<T0, T1, T2, T3, T4, T5, T6, T7>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema>(items: [T0, T1, T2, T3, T4, T5, T6], options?: UserDefinedOptions): TUnion7<T0, T1, T2, T3, T4, T5, T6>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema>(items: [T0, T1, T2, T3, T4, T5], options?: UserDefinedOptions): TUnion6<T0, T1, T2, T3, T4, T5>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema>(items: [T0, T1, T2, T3, T4], options?: UserDefinedOptions): TUnion5<T0, T1, T2, T3, T4>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema>(items: [T0, T1, T2, T3], options?: UserDefinedOptions): TUnion4<T0, T1, T2, T3>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema>(items: [T0, T1, T2], options?: UserDefinedOptions): TUnion3<T0, T1, T2>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema, T1 extends TSchema>(items: [T0, T1], options?: UserDefinedOptions): TUnion2<T0, T1>;
    /** Creates a Union type for the given arguments. */
    static Union<T0 extends TSchema>(items: [T0], options?: UserDefinedOptions): TUnion1<T0>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema>(items: [T0, T1, T2, T3, T4, T5, T6, T7], options?: UserDefinedOptions): TIntersect8<T0, T1, T2, T3, T4, T5, T6, T7>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema>(items: [T0, T1, T2, T3, T4, T5, T6], options?: UserDefinedOptions): TIntersect7<T0, T1, T2, T3, T4, T5, T6>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema>(items: [T0, T1, T2, T3, T4, T5], options?: UserDefinedOptions): TIntersect6<T0, T1, T2, T3, T4, T5>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema>(items: [T0, T1, T2, T3, T4], options?: UserDefinedOptions): TIntersect5<T0, T1, T2, T3, T4>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema>(items: [T0, T1, T2, T3], options?: UserDefinedOptions): TIntersect4<T0, T1, T2, T3>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema>(items: [T0, T1, T2], options?: UserDefinedOptions): TIntersect3<T0, T1, T2>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema, T1 extends TSchema>(items: [T0, T1], options?: UserDefinedOptions): TIntersect2<T0, T1>;
    /** Creates an Intersect type for the given arguments. */
    static Intersect<T0 extends TSchema>(items: [T0], options?: UserDefinedOptions): TIntersect1<T0>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema, T7 extends TSchema>(items: [T0, T1, T2, T3, T4, T5, T6, T7], options?: UserDefinedOptions): TTuple8<T0, T1, T2, T3, T4, T5, T6, T7>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema, T6 extends TSchema>(items: [T0, T1, T2, T3, T4, T5, T6], options?: UserDefinedOptions): TTuple7<T0, T1, T2, T3, T4, T5, T6>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema, T5 extends TSchema>(items: [T0, T1, T2, T3, T4, T5], options?: UserDefinedOptions): TTuple6<T0, T1, T2, T3, T4, T5>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema, T4 extends TSchema>(items: [T0, T1, T2, T3, T4], options?: UserDefinedOptions): TTuple5<T0, T1, T2, T3, T4>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema, T3 extends TSchema>(items: [T0, T1, T2, T3], options?: UserDefinedOptions): TTuple4<T0, T1, T2, T3>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema, T2 extends TSchema>(items: [T0, T1, T2], options?: UserDefinedOptions): TTuple3<T0, T1, T2>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema, T1 extends TSchema>(items: [T0, T1], options?: UserDefinedOptions): TTuple2<T0, T1>;
    /** Creates a Tuple type for the given arguments. */
    static Tuple<T0 extends TSchema>(items: [T0], options?: UserDefinedOptions): TTuple1<T0>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, T5 extends TStatic, T6 extends TStatic, T7 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4, T5, T6, T7], returns: U, options?: UserDefinedOptions): TFunction8<T0, T1, T2, T3, T4, T5, T6, T7, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, T5 extends TStatic, T6 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4, T5, T6], returns: U, options?: UserDefinedOptions): TFunction7<T0, T1, T2, T3, T4, T5, T6, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, T5 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4, T5], returns: U, options?: UserDefinedOptions): TFunction6<T0, T1, T2, T3, T4, T5, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4], returns: U, options?: UserDefinedOptions): TFunction5<T0, T1, T2, T3, T4, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3], returns: U, options?: UserDefinedOptions): TFunction4<T0, T1, T2, T3, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, U extends TStatic>(args: [T0, T1, T2], returns: U, options?: UserDefinedOptions): TFunction3<T0, T1, T2, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, T1 extends TStatic, U extends TStatic>(args: [T0, T1], returns: U, options?: UserDefinedOptions): TFunction2<T0, T1, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<T0 extends TStatic, U extends TStatic>(args: [T0], returns: U, options?: UserDefinedOptions): TFunction1<T0, U>;
    /** Creates a `function` type for the given arguments. */
    static Function<U extends TStatic>(args: [], returns: U, options?: UserDefinedOptions): TFunction0<U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, T5 extends TStatic, T6 extends TStatic, T7 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4, T5, T6, T7], returns: U, options?: UserDefinedOptions): TConstructor8<T0, T1, T2, T3, T4, T5, T6, T7, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, T5 extends TStatic, T6 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4, T5, T6], returns: U, options?: UserDefinedOptions): TConstructor7<T0, T1, T2, T3, T4, T5, T6, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, T5 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4, T5], returns: U, options?: UserDefinedOptions): TConstructor6<T0, T1, T2, T3, T4, T5, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, T4 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3, T4], returns: U, options?: UserDefinedOptions): TConstructor5<T0, T1, T2, T3, T4, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, T3 extends TStatic, U extends TStatic>(args: [T0, T1, T2, T3], returns: U, options?: UserDefinedOptions): TConstructor4<T0, T1, T2, T3, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, T2 extends TStatic, U extends TStatic>(args: [T0, T1, T2], returns: U, options?: UserDefinedOptions): TConstructor3<T0, T1, T2, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, T1 extends TStatic, U extends TStatic>(args: [T0, T1], returns: U, options?: UserDefinedOptions): TConstructor2<T0, T1, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<T0 extends TStatic, U extends TStatic>(args: [T0], returns: U, options?: UserDefinedOptions): TConstructor1<T0, U>;
    /** Creates a `constructor` type for the given arguments. */
    static Constructor<U extends TStatic>(args: [], returns: U, options?: UserDefinedOptions): TConstructor0<U>;
    /** Creates a `Promise<T>` type. */
    static Promise<T extends TSchema>(item: T, options?: UserDefinedOptions): TPromise<T>;
    /** Creates a `void` type. */
    static Void(options?: UserDefinedOptions): TVoid;
    /** Creates a `undefined` type. */
    static Undefined(options?: UserDefinedOptions): TUndefined;
    /** Creates a `string` literal for the given value. */
    static Literal<T extends string>(value: T, options?: UserDefinedOptions): TStringLiteral<T>;
    /** Creates a `number` literal for the given value. */
    static Literal<T extends number>(value: T, options?: UserDefinedOptions): TNumberLiteral<T>;
    /** Creates a `boolean` literal for the given value. */
    static Literal<T extends boolean>(value: T, options?: UserDefinedOptions): TBooleanLiteral<T>;
    /** Creates a `object` type with the given properties. */
    static Object<T extends TProperties>(properties: T, options?: UserDefinedOptions): TObject<T>;
    /** Creates a `{[key: string]: T}` type for the given item. */
    static Map<T extends TSchema | TUnion | TIntersect | TTuple>(item: T, options?: UserDefinedOptions): TMap<T>;
    /** Creates an `Array<T>` type for the given item.` */
    static Array<T extends TSchema | TUnion | TIntersect | TTuple>(items: T, options?: ArrayOptions): TArray<T>;
    /** Creates an `Enum<T>` from an existing TypeScript enum definition. */
    static Enum<T extends Record<string, string | number>>(item: T, options?: UserDefinedOptions): TEnum<T[keyof T]>;
    /** Creates a `string` type. */
    static String(options?: StringOptions): TString;
    /** Creates a `number` type. */
    static Number(options?: NumberOptions): TNumber;
    /** Creates a `number` type that checks for `integer`. */
    static Integer(options?: NumberOptions): TInteger;
    /** Creates a `boolean` type. */
    static Boolean(options?: UserDefinedOptions): TBoolean;
    /** Creates a `null` type. */
    static Null(options?: UserDefinedOptions): TNull;
    /** Creates a `any` type. */
    static Any(options?: UserDefinedOptions): TAny;
    /** Creates a `string` type that validates for the given regular expression. Alias for ```Type.String({ pattern: '...' })``` */
    static Pattern(regex: RegExp): TString;
    /**
     * Deprecated: Use `Type.String({ format: 'uuid' })`
     *
     * Creates a `string` type that validate a Guid. Alias for ```Type.String({ pattern: '...' })```
     */
    static Guid(): TString;
}
export {};
